Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2469 by niro, Tue Jan 7 20:52:44 2014 UTC revision 2950 by niro, Thu Jun 16 08:43:55 2016 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
15    
# Line 39  do Line 40  do
40   fi   fi
41  done  done
42    
43  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # fetch cmdline
44  # -> now in images.conf  for argv in $*
45  CDIMAGENAME=""  do
46  TOTALLINES=""   case $1 in
47  CURRENTLINE=0   --liveroot) shift; cmdliveroot="$1" ;;
48  if [ -e /mnt/cdrom/system/images.conf ]   --imageroot) shift; cmdimageroot="$1" ;;
49  then   --installroot) shift; cmdinstallroot="$1" ;;
50   source /mnt/cdrom/system/images.conf   --filesystem) shift; cmdformatfilesystem="$1" ;;
51   # check if all required variables are set   --help)
52   [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"   echo "$0 options:"
53   [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"   echo " --liveroot [path]     - override default liveroot"
54  else   echo " --imageroot [path]    - override default imageroot"
55   die "/mnt/cdrom/system/images.conf not found"   echo " --installroot [path]  - override default installroot"
56  fi   echo " --filesystem [fstype] - override default filesystem used to format the disk"
57     exit 0 ;;
58     esac
59     shift
60    done
61    
62  ### System/Config Version  ### System/Config Version
63  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
64  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
65    
66    # initialize global variables so they are exportable
67  # some sane defaults  # some sane defaults
68  CDROOT="${DEFAULT_CDROOT}"  INSTALL_METHOD=""
69  INSTALLROOT="${DEFAULT_INSTALLROOT}"  if [[ -n ${cmdliveroot} ]]
70    then
71     LIVEROOT="${cmdliveroot}"
72    else
73     LIVEROOT="${DEFAULT_LIVEROOT}"
74    fi
75    if [[ -n ${cmdimageroot} ]]
76    then
77     IMAGEROOT="${cmdimageroot}"
78    else
79     IMAGEROOT="${DEFAULT_IMAGEROOT}"
80    fi
81    if [[ -n ${cmdinstallroot} ]]
82    then
83     INSTALLROOT="${cmdinstallroot}"
84    else
85     INSTALLROOT="${DEFAULT_INSTALLROOT}"
86    fi
87  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
88  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
89  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
# Line 68  GRUB2OPTS="" Line 91  GRUB2OPTS=""
91  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
92  SPECIALDEVICE=""  SPECIALDEVICE=""
93  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
94  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  if [[ -n ${cmdformatfilesystem} ]]
95    then
96     FORMAT_FILESYSTEM="${cmdformatfilesystem}"
97    else
98     FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
99    fi
100    FLASHDISK=0
101    
102  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
103  #  DIALOG BOXEN #  # -> now in images.conf
104  #################################################  CDIMAGENAME=""
105    TOTALLINES=""
106    CURRENTLINE=0
107    if [ -e ${IMAGEROOT}/images.conf ]
108    then
109     source ${IMAGEROOT}/images.conf
110     # check if all required variables are set
111     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
112     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
113    else
114     die "${IMAGEROOT}/images.conf not found"
115    fi
116    
117    ### helper scripts ###
118    
119  trap_exit()  trap_exit()
120  {  {
# Line 81  trap_exit() Line 123  trap_exit()
123   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
124   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
125   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
126     [[ -n ${SWAPHDD} ]] && swapoff ${SWAPHDD}
127    
128   echo $"Installation aborted."   echo $"Installation aborted."
129   exit 1   exit 1
130  }  }
131    
132  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"Please create 1 partition.\n\n[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace.\nPlease mark ${SHDD}1 \Z3bootable\Zn."  
 }  
   
 dialog_setup_hdd_info_auto()  
133  {  {
134   local SHDD="${HDD//\/dev\/}"   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
135     do
136   messagebox -h $"[ Harddrive partitioning ]" \   CURRENTLINE=$(grep -c . /tmp/install.log)
137   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
138     echo ${PERCENT}
139     sleep 1
140     done
141     rm -f /tmp/install.log
142     return 0
143  }  }
144    
145  dialog_setup_system_menu()  mount_rootfs()
146  {  {
  local mode  
147   local retval   local retval
148    
149   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \   if [[ -n ${SWAPHDD} ]]
  $"1:Automatic setup (recommended)" \  
  ":" \  
  $":\Z1Expert modes:\Zn" \  
  $"2:Common IDE-disk (manual setup)")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case "${mode}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
150   then   then
151   for i in ${ALL_DISKS}   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
152   fi   fi
153    
154   if [[ ! -z ${ALL_CDROMS} ]]   if [[ -n ${ROOTHDD} ]]
155   then   then
156   message+="\n"   if is_mounted --location "${INSTALLROOT}"
157   message+=$"Optical disk drives:\n"   then
158   for i in ${ALL_CDROMS}   echo $"${INSTALLROOT} already mounted" >&2
159   do   else
160   message+="\Z3${i}\Zn"   mount -t "${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
161   done   fi
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n \\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"  
162   fi   fi
163    
164   messagebox -y 12 -h $"Detected hardware:" "${message}"   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
 }  
   
 dialog_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
165    
166   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${BOOTHDD} ]]
167   then   then
168   dialog_no_harddrive_found   if is_mounted --location "${INSTALLROOT}"/boot
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
169   then   then
170   dialog_setup_hdd_info   echo $"${INSTALLROOT}/boot already mounted" >&2
171   setup_hdd_partitions_manual   else
172     mount -t "${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
173   fi   fi
174   fi   fi
175  }  }
176    
177  dialog_setup_hdd_partitions_auto()  umount_rootfs()
178  {  {
179   local i   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
180   local retval   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
181    
182   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${SWAPHDD} ]]
183   then   then
184   dialog_no_harddrive_found   swapoff ${SWAPHDD} || die
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
185   fi   fi
186  }  }
187    
188  install_meter()  install_do_reboot()
 {  
  while [[ ${CURRENTLINE} != ${TOTALLINES} ]]  
  do  
  CURRENTLINE=$(grep -c . /tmp/install.log)  
  PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))  
  echo ${PERCENT}  
  sleep 1  
  done  
  rm -f /tmp/install.log  
  return 0  
 }  
   
 dialog_main()  
189  {  {
190   local method=0   reboot
  local retval  
   
  while [[ ${method} -le 2 ]]  
  do  
  method=$(CANCEL_LABEL=$"Exit "menubox $"Configuration:" \  
  $"1:Install system" \  
  $"2:Show detected harddrives" \  
  $"3:Exit and reboot" \  
  $"4:Exit and drop into a shell")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
191  }  }
192    
 #################################################  
 # Install Komandos #  
 #################################################  
193  run_hardware_detection()  run_hardware_detection()
194  {  {
195   local hwinfo   local hwinfo
   
196   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
197    
198   ## check for special devices/clients:   # check for special devices/clients:
199   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
200   #local removable=0   local removable=0
201   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
202   #then   then
203   #for i in /sys/block/[hs]d*/removable   for i in /sys/block/[hs]d*/removable
204   #do   do
205   #if [[ $(< ${i}) = 1 ]]   if [[ $(< ${i}) = 1 ]]
206   #then   then
207   #removable=1   removable=1
208   #fi   # we assume that all removable disks are flash disks on a zotac
209   #done   export FLASHDISK=1
210   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   fi
211     done
212   ## only add this for grub legacy, grub2 detect these settings on its own   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
213   #export GRUBLEGACYOPTS="rootdelay=8"  
214   ## there are to zotac types in the wild, nvidia based gfx and intel   # only add this for grub legacy, grub2 detect these settings on its own
215   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   export GRUBLEGACYOPTS="rootdelay=8"
216   #then   # there are to zotac types in the wild, nvidia based gfx and intel
217   #export SPECIALDEVICE="zotac_nvidia"   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
218   #else   then
219   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_nvidia"
220   #fi   else
221   #fi   export SPECIALDEVICE="zotac_intel"
222     fi
223     fi
224    
225   # check for special devices/clients:   # check for special devices/clients:
226   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 324  run_hardware_detection() Line 240  run_hardware_detection()
240   export GRUBLEGACYOPTS=""   export GRUBLEGACYOPTS=""
241   fi   fi
242    
243     # check for i845 Chipsets and enable KMS and use 915 drm driver later in initrd
244     if [[ ! -z $(echo "${hwinfo}" | grep -i i845) ]]
245     then
246     export SPECIALDEVICE="i845"
247     # unset default video=1024x768 opt or the drm driver breaks
248     export KERNELOPTS="quiet"
249     export GRUBLEGACYOPTS=""
250     # enable full kms support
251     export GRUB2GFXPAYLOAD="keep"
252     fi
253    
254     # check for radeon gfxcards
255     if [[ ! -z $(echo "${hwinfo}" | grep -i radeon) ]]
256     then
257     # enable full kms support
258     export GRUB2GFXPAYLOAD="keep"
259     fi
260    
261     # requires nomsi to prevent massive IRQ error spam
262     # see: http://ubuntuforums.org/showthread.php?t=1234983
263     if [[ ! -z $(echo "${hwinfo}" | grep -i 'P5VD2-X') ]] || [[ ! -z $(echo "${hwinfo}" | grep -i 'VT8237') ]] || [[ ! -z $(echo "${hwinfo}" | grep -i 'VX700') ]]
264     then
265     export SPECIALDEVICE="nomsi"
266     export KERNELOPTS="${KERNELOPTS} pci=nomsi,noaer"
267     fi
268    
269   # check for special devices/clients:   # check for special devices/clients:
270   # check for laptops and activate cpufreq scaling   # check for laptops and activate cpufreq scaling
271   if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]   if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
# Line 340  run_hardware_detection_disks() Line 282  run_hardware_detection_disks()
282   # all disks but exclude ramdisks   # all disks but exclude ramdisks
283   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
284   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
285   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
286   then   then
287   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
288   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
289   fi   fi
290   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
291  }  }
292    
293  hdd_size_below_256mb()  auto_partition_clear_disk()
294  {  {
295   local hdd="$1"   if [ -e ${HDD} ]
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
   
  size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')  
  if [[ ${size} -le 257000000 ]]  
296   then   then
297   retval="0"   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
298   else   else
299   retval="1"   echo "clear disk: device ${HDD} does not exist" >&2
300   fi   fi
   
  return "${retval}"  
301  }  }
302    
303  setup_hdd_partitions_auto()  auto_partition_command()
304  {  {
305   ROOTHDD="${HDD}1"   if [ -e ${HDD} ]
   
  # sanity check - should not happen  
  if is_mounted --device "${ROOTHDD}"  
306   then   then
  echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2  
  umount "${ROOTHDD}"  
  fi  
   
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
  then  
  if hdd_size_below_256mb ${HDD}  
  then  
  FDISKPARTIONBELOW256MB=1  
  else  
  FDISKPARTIONBELOW256MB=0  
  fi  
  fi  
   
  ## delete disk  
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
  then  
  ## setup one bootable partition  
  #1. n= new disk  
  #2. p= primary disk  
  #3. 1= first partition  
  #4. 2= default sector start // small disk needs more space for grub2 mbr sector  
  #5. ''= defaul sector end  
  #6. a= bootable flag  
  #7. 1= boot flag for partition 1  
  #8. w= write/quit  
307   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
308  n  $(echo "${PARTITION_OPTS}")
 p  
 1  
 2  
   
 a  
 1  
 w  
309  EOF  EOF
310   else   else
311   ## setup one bootable partition   echo "partition command: device ${HDD} does not exist" >&2
  #1. n= new disk  
  #2. p= primary disk  
  #3. 1= first partition  
  #4. ''= default sector start  
  #5. ''= defaul sector end  
  #6. a= bootable flag  
  #7. 1= boot flag for partition 1  
  #8. w= write/quit  
  fdisk ${HDD} &> /dev/null << EOF  
 n  
 p  
 1  
   
   
 a  
 1  
 w  
 EOF  
312   fi   fi
313  }  }
314    
315  setup_hdd_partitions_manual()  setup_hdd_partitions()
316  {  {
317   ROOTHDD="${HDD}1"   local partition_number
318   SWAPHDD=""   local partition_type
319   BOOTHDD=""   local partition_start_sector
320   cfdisk ${HDD} || dialog_die   local partition_size
 }  
321    
 setup_hdd_format()  
 {  
322   # sanity check - should not happen   # sanity check - should not happen
323   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
324   then   then
325   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
326   umount "${ROOTHDD}"   umount "${ROOTHDD}"
327   fi   fi
328     if [[ -n ${BOOTHDD} ]]
  mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die  
 }  
   
 install_mount_rootfs()  
 {  
  is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
  install -d ${INSTALLROOT}/boot || dialog_die  
 }  
   
 install_system_image()  
 {  
  pushd ${INSTALLROOT} > /dev/null  
  tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}  
  popd > /dev/null  
 }  
   
 disabled_install_bootsector_chroot()  
 {  
  local my_roothdd  
  local grubconf="${INSTALLROOT}/boot/grub/grub.conf"  
  local grub2conf="/boot/grub/grub.cfg"  
   
  # check for grub2  
  if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]  
329   then   then
330   # needed by grub-mkconfig on the first run   if is_mounted --device "${BOOTHDD}"
  if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]  
331   then   then
332   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
333     umount "${BOOTHDD}"
334   fi   fi
335     fi
336    
337   # set kernelopts   if [[ ${INSTALL_METHOD} = auto ]]
338   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]   then
339   then   # run this only if FDISKPARTITIONBELOW256MB is not already 1
340   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
  else  
  CONFIG="${INSTALLROOT}/etc/conf.d/grub"  
  clearconfig  
  addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""  
  fi  
  CONFIG="${INSTALLROOT}/root/.installrc"  
  clearconfig  
  # only grub 1.99  
  addconfig 'type -P grub-mkdevicemap && grub-mkdevicemap'  
  addconfig "grub-install --no-floppy ${HDD} &> /dev/null"  
  addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null"  
  addconfig "exit 0"  
   
  # grub-legacy  
  else  
  source ${INSTALLROOT}/boot/kernelversion  
   
  if [ -e ${INSTALLROOT}/etc/alx_version ]  
341   then   then
342   OLD_ALXVER="${ALXVER}"   if device_minimum_size "${HDD}" 256
343   source ${INSTALLROOT}/etc/alx_version   then
344   KRNVER="ALX-${ALXVER}"   FDISKPARTIONBELOW256MB=1
345   ALXVER="${OLD_ALXVER}"   else
346     FDISKPARTIONBELOW256MB=0
347     fi
348   fi   fi
349    
350   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"   ## delete disk
351   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"   auto_partition_clear_disk
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
   
  # uuid support  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
352    
353   CONFIG="${grubconf}"   # setup partition options
354   clearconfig   export PARTITION_OPTS
  addconfig "default 0"  
  addconfig "timeout 3"  
  # using current root password  
  addconfig "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  
355    
356   addconfig   if [[ -n ${BOOTHDD} ]]
  addconfig "# normal boot"  
  addconfig "title ${KRNVER}"  
  addconfig "root (hd0,0)"  
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"  
  if is_initrd_supported  
357   then   then
358   addconfig "initrd /boot/${KRNINITRD}"   # create a boot disk with 50meg size - bootable
359     partition_type="p"
360     partition_number="1"
361     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
362     then
363     # 2= default sector start // small disk needs more space for grub2 mbr sector
364     partition_start_sector="2"
365     else
366     # '' use default sector start
367     partition_start_sector=""
368     fi
369     # 50meg size
370     partition_size="+50M"
371    
372     # create a boot disk with 50meg size - bootable
373     # n= new disk
374     # p= primary disk
375     # w= write/quit
376     PARTITION_OPTS="n
377    ${partition_type}
378    ${partition_number}
379    ${partition_start_sector}
380    ${partition_size}
381    w"
382     # create the disk
383     auto_partition_command
384    
385     # mark the disk bootable
386     PARTITION_OPTS="a
387    ${partition_number}
388    w"
389     auto_partition_command
390    
391   fi   fi
392    
393   addconfig   if [[ -n ${SWAPHDD} ]]
394   addconfig "# admin boot"   then
395   addconfig "title ${KRNVER} - Re-run hardware-detection"   # p= primary disk
396   addconfig "lock"   partition_type="p"
397   addconfig "root (hd0,0)"   if [[ -n ${BOOTHDD} ]]
398   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"   then
399   if is_initrd_supported   # boot disk exist, partition 2
400   then   partition_number="2"
401   addconfig "initrd /boot/${KRNINITRD}"   else
402     # boot disk does not exist, partition 1
403     partition_number="1"
404     fi
405     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
406     then
407     # fake sector 2 and fdisk finds the next free sector which must be selected with enter
408     partition_start_sector="2
409    "
410     else
411     # '' use default sector start
412     partition_start_sector=""
413     fi
414     partition_start_sector=""
415     # +2G disk size
416     partition_size="+2G"
417    
418     # create a swap disk with 2GB size
419     PARTITION_OPTS="n
420    ${partition_type}
421    ${partition_number}
422    ${partition_start_sector}
423    ${partition_size}
424    w"
425     # create the disk
426     auto_partition_command
427    
428     # mark disk as swap space
429     PARTITION_OPTS="
430    t"
431     if [[ ${partition_number} != 1 ]]
432     then
433     PARTITION_OPTS+="
434    ${partition_number}"
435     fi
436     PARTITION_OPTS+="
437    82
438    w"
439     auto_partition_command
440   fi   fi
441    
442   addconfig   if [[ -n ${ROOTHDD} ]]
  addconfig "title ${KRNVER} - Reset *all* local settings"  
  addconfig "lock"  
  addconfig "root (hd0,0)"  
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"  
  if is_initrd_supported  
443   then   then
444   addconfig "initrd /boot/${KRNINITRD}"   # p= primary disk
445   fi   partition_type="p"
446     if [[ -z ${BOOTHDD} ]] && [[ -z ${SWAPHDD} ]]
447     then
448     # boot and swap disk does not exist, partition 1
449     partition_number="1"
450     fi
451     if [[ -n ${BOOTHDD} ]] || [[ -n ${SWAPHDD} ]]
452     then
453     # boot or swap disk exist, partition 2
454     partition_number="2"
455     fi
456     if [[ -n ${BOOTHDD} ]] && [[ -n ${SWAPHDD} ]]
457     then
458     # boot and swap disk does exist, partition 3
459     partition_number="3"
460     fi
461     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
462     then
463     if [[ -z ${BOOTHDD} ]]
464     then
465     # 2= default sector start // small disk needs more space for grub2 mbr sector
466     partition_start_sector="2"
467     else
468     # fake sector 2 and fdisk finds the next free sector which must be selected with enter
469     partition_start_sector="2
470    "
471     fi
472     else
473     # '' use default sector start
474     partition_start_sector=""
475     fi
476     # '' default sector end
477     partition_size=""
478    
479   # bootsector schreiben chrooted schreiben (lfs/magellan)   # create system disk with remaining space
480   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   # w= write/quit
481  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null   PARTITION_OPTS="n
482  root (hd0,0)  ${partition_type}
483  setup (hd0)  ${partition_number}
484  quit  ${partition_start_sector}
485  EOF  ${partition_size}
486  exit 0  w"
487  CHROOTEOF   # create the disk
488     auto_partition_command
489    
490     # no boot disk? then this is the boot disk
491     if [[ -z ${BOOTHDD} ]]
492     then
493     # mark the disk bootable
494     PARTITION_OPTS="a
495    ${partition_number}
496    w"
497     auto_partition_command
498     fi
499     fi
500     else
501     cfdisk ${HDD} || dialog_die
502   fi   fi
503    }
504    
505   # run installrc  setup_hdd_format()
506   chrooted /bin/bash --rcfile /root/.installrc -i  {
507   rm ${INSTALLROOT}/root/.installrc   install -d /tmp
508  }   :> /tmp/format.log
   
 disabled_install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
509    
510   if [[ ${FORMFACTOR} = laptop ]]   if [[ -n ${SWAPHDD} ]]
511   then   then
512   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   # sanity check - should not happen
513     if is_mounted --device "${SWAPHDD}"
514     then
515     echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
516     umount "${SWAPHDD}"
517     fi
518     mkswap ${SWAPHDD} || die
519   fi   fi
520    
521   # install an appropriate uvesafb.conf   if [[ -n ${BOOTHDD} ]]
522   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die   then
523   CONFIG="${INSTALLROOT}/etc/modprobe.d/uvesafb.conf"   # sanity check - should not happen
524   clearconfig   if is_mounted --device "${BOOTHDD}"
525   addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"   then
526     echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
527     umount "${BOOTHDD}"
528     fi
529    
530   # install an appropriate viafb.conf   mkfs."${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
531   CONFIG="${INSTALLROOT}/etc/modprobe.d/viafb.conf"   fi
  clearconfig  
  addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"  
532    
533   # install an appropriate i810fb.conf   if [[ -n ${ROOTHDD} ]]
534   CONFIG="${INSTALLROOT}/etc/modprobe.d/i810fb.conf"   then
535   clearconfig   # sanity check - should not happen
536   addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"   if is_mounted --device "${ROOTHDD}"
537     then
538     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
539     umount "${ROOTHDD}"
540     fi
541    
542   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   mkfs."${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
543  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd   fi
544  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  }
 exit 0  
 CHROOTEOF  
545    
546   # run installrc  install_system_image()
547   chrooted /bin/bash --rcfile /root/.installrc -i  {
548   rm ${INSTALLROOT}/root/.installrc   pushd ${INSTALLROOT} > /dev/null
549     tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
550     popd > /dev/null
551  }  }
552    
553  install_system_settings()  install_system_settings()
# Line 633  install_system_settings() Line 557  install_system_settings()
557   # write fstab   # write fstab
558   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
559   clearconfig   clearconfig
560   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
561     then
562     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM_BOOTHDD}\tdefaults,noatime\t1 1"
563     fi
564     if [[ -n ${ROOTHDD} ]]
565     then
566     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tdefaults,noatime\t0 0"
567     fi
568     if [[ -n ${SWAPHDD} ]]
569     then
570     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
571     fi
572   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
573   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
574    
# Line 644  install_system_settings() Line 579  install_system_settings()
579   addconfig 'NETWORKING="dhcp"'   addconfig 'NETWORKING="dhcp"'
580    
581   # intel framebuffer quirk   # intel framebuffer quirk
582   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
583     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
584   then   then
585   if [ -e /proc/fb ]   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
586   then   then
587   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
588   then   [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
589   fi   fi
590   fi   fi
591  }  }
592    
593  install_umount_rootfs()  
594    ### installer dialogs ###
595    
596    dialog_die()
597  {  {
598   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   ERROR="$1"
599   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   RETVAL="$?"
600     dialog_install_failure
601     exit 1
602  }  }
603    
604  install_do_reboot()  dialog_warning()
605  {  {
606   reboot   local retval
607    
608     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
609     retval=$?
610     if [[ ${retval} -eq 1 ]]
611     then
612     clear
613     echo $"The process was aborted."
614     exit 1
615     fi
616  }  }
617    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
618    
619  run_install_normal()  ### installer tasks ###
620    
621    task_setup_system_menu()
622  {  {
623   dialog_hardware_detection   local mode
624     local retval
625    
626   dialog_setup_hdd_partitions_manual   mode="$(dialog_setup_system_menu)"
627   dialog_setup_hdd_format   retval=$?
628   setup_hdd_format > /dev/null   [[ ${retval} -eq 1 ]] && return 1
629   install_mount_rootfs   if [[ ${retval} -eq 0 ]]
630   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   then
631     case "${mode}" in
632     "1") run_install auto ;;
633     "2") run_install normal ;;
634     "") task_setup_system_menu;;
635     esac
636     fi
637    }
638    
639   dialog_install_settings  task_hardware_detection()
640   sleep 1  {
641   install_system_settings   local message
642   if is_initrd_supported  
643     run_hardware_detection_disks
644    
645     message+=$"Harddrives:\n"
646    
647     if [[ ! -z ${ALL_DISKS} ]]
648   then   then
649   dialog_install_initrd   for i in ${ALL_DISKS}
650   initrd_config   do
651   initrd_install   message+="\Z3${i}\Zn "
652     done
653     message+="\n"
654   fi   fi
655    
656   dialog_install_bootsector   if [[ ! -z ${ALL_CDROMS} ]]
657   bootloader_config   then
658   bootloader_install   message+="\n"
659     message+=$"Optical disk drives:\n"
660     for i in ${ALL_CDROMS}
661     do
662     message+="\Z3${i}\Zn"
663     done
664     message+="\n"
665     fi
666    
667   install_umount_rootfs   # other devices
668   dialog_install_successful   run_hardware_detection
669     case "${SPECIALDEVICE}" in
670     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
671     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
672     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
673     i845) message+=$"\n\Z2Intel i845 VGA device detected.\Zn" ;;
674     nomsi) message+=$"\n\Z2Mainboard with P5VD2-X/VT8237/VX700 chipset detected.\Zn"
675     message+=$"\n\Z2Disabling Message Signaled Interrupts (MSI) capability of the kernel.\Zn" ;;
676     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
677     esac
678     if [[ ${FORMFACTOR} = laptop ]]
679     then
680     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
681     fi
682     if [[ ${FLASHDISK} = 1 ]]
683     then
684     message+=$"\n\ZnFlash memory detected.\Zn"
685     message+=$"\n\ZnF2FS will be used as default filesystem within the auto installation mode.\Zn"
686     fi
687    
688     messagebox -y 12 -h $"Detected hardware:" "${message}"
689    }
690    
691    task_select_target_hdd()
692    {
693     if [[ -z ${ALL_DISKS} ]]
694     then
695     dialog_no_harddrive_found
696     exit 1
697     else
698     export HDD=$(dialog_select_target_harddrive)
699     fi
700    }
701    
702    task_setup_hdd_partitions()
703    {
704     local retval
705    
706     if [[ -z ${HDD} ]]
707     then
708     dialog_no_harddrive_found
709     exit 1
710     else
711     dialog_setup_hdd_info
712     setup_hdd_partitions
713     fi
714  }  }
715    
716  run_install_auto()  task_main()
717  {  {
718   dialog_hardware_detection   local method=0
719     local retval
720    
721     while [[ ${method} -le 2 ]]
722     do
723     method=$(dialog_main)
724     retval=$?
725     [[ ${retval} -eq 1 ]] && exit 1
726     if [[ ${retval} -eq 0 ]]
727     then
728     case ${method} in
729     "1") task_setup_system_menu ;;
730     "2") task_hardware_detection ;;
731     "3") install_do_reboot ;;
732     "4") /bin/bash --login -i ;;
733     esac
734     fi
735     done
736    }
737    
738    run_install()
739    {
740     local method="$1"
741    
742     task_hardware_detection
743     task_select_target_hdd
744    
745     case "${method}" in
746     auto)
747     if [[ ${FLASHDISK} = 1 ]]
748     then
749     export BOOTHDD="${HDD}1"
750     export SWAPHDD=""
751     export ROOTHDD="${HDD}2"
752     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
753     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
754     else
755     # ext4 seems not to be compatible again
756     if [[ ${FORMAT_FILESYSTEM} = ext4 ]]
757     then
758     export BOOTHDD="${HDD}1"
759     export SWAPHDD=""
760     export ROOTHDD="${HDD}2"
761     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
762     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
763     else
764     export BOOTHDD=""
765     export SWAPHDD=""
766     export ROOTHDD="${HDD}1"
767     export FORMAT_FILESYSTEM_BOOTHDD=""
768     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
769     fi
770     fi
771     export INSTALL_METHOD="${method}"
772     ;;
773     normal)
774     export BOOTHDD="${HDD}1"
775     export SWAPHDD="${HDD}2"
776     export ROOTHDD="${HDD}3"
777     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
778     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
779     export INSTALL_METHOD="${method}"
780     ;;
781     single)
782     export BOOTHDD=""
783     export SWAPHDD=""
784     export ROOTHDD="${HDD}1"
785     export FORMAT_FILESYSTEM_BOOTHDD=""
786     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
787     export INSTALL_METHOD="${method}"
788     ;;
789     flash)
790     export BOOTHDD="${HDD}1"
791     export SWAPHDD=""
792     export ROOTHDD="${HDD}2"
793     export FORMAT_FILESYSTEM_BOOTHDD="ext2"
794     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
795     export INSTALL_METHOD="${method}"
796     ;;
797     *)
798     die "Unknown install method '${method}', aborting."
799     ;;
800     esac
801    
802   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions
803   dialog_setup_hdd_format   dialog_setup_hdd_format
804   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
805   install_mount_rootfs   mount_rootfs
806   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
807    
808   dialog_install_settings   dialog_install_settings
# Line 727  run_install_auto() Line 819  run_install_auto()
819   bootloader_config   bootloader_config
820   bootloader_install   bootloader_install
821    
822   install_umount_rootfs   umount_rootfs
823   dialog_install_successful   dialog_install_successful
824  }  }
825    
826  # set some proper traps  # set some proper traps
827  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
828    
829  dialog_main  task_main
830    
831  exit 0  exit 0

Legend:
Removed from v.2469  
changed lines
  Added in v.2950